#!/bin/sh

DEV=$1
DEVFILE=/dev/${DEV}

state=;
if [ -r "/tmp/mountDev" ]; then
  state=`cat /tmp/mountDev`
fi
if [ "X$state" == "Xoff" ]; then
    echo  "not to mount ${DEV} ... " > /dev/console
    exit 1
fi

inMount=;
if [ -r "/tmp/mounting" ]; then
  inMount=`cat /tmp/mounting`
fi
if [ "X$inMount" == "Xgoing" ]
then 
    echo  " wait: be mounting ... " > /dev/console
    exit 2
fi

echo "going" > /tmp/mounting
wrap_exit()
{
   	ret=$1;
   	echo "0" > /tmp/mounting
   	exit ${ret}  	
}

forceMt=;
if [ $# -gt 1 ];  then
   forceMt=$2
   echo ${forceMt}
fi

echo  "Mounting partition ${DEV} ... " > /dev/console

if [ "X${DEV}" != "Xsda1" ] && [ "X${DEV}" != "Xsdb1" ]; then
   echo "WARNING:not supported dev ${DEV} !!"  > /dev/console
   if [ "X${forceMt}" != "X1" ]; then
       wrap_exit 3;
   fi
fi

# Use vol_id to get the all the data about
# the new storage
ID_FS_TYPE=$(/lib/udev/vol_id ${DEVFILE} | grep ID_FS_TYPE | sed -e 's/ID_FS_TYPE=//');
ID_FS_LABEL_SAFE=$(/lib/udev/vol_id ${DEVFILE} | grep ID_FS_LABEL_SAFE | sed -e 's/ID_FS_LABEL_SAFE=//');
case ${ID_FS_TYPE} in
    "vfat") 
        FS_TYPE="vfat";
        FS_MODULES="vfat nls_cp437 nls_ascii";
        FS_OPTIONS="fmask=0000,dmask=0000,quiet";
        ;;
    *) 
        echo  "error: filesystem type(${FS_TYPE}) not soppurted" > /dev/console;
        wrap_exit 4;
        ;;
esac

case $1 in
   sda*) 
           MOUNT_POINT=/media/sdcard;
           ;;
   sdb*) 
           MOUNT_POINT=/media/usb;
           ;;
   *)   
           MOUNT_POINT=/media/ezdvr;
           ;;
esac

if [ ! -d ${MOUNT_POINT} ]; then
    mkdir -p ${MOUNT_POINT};
    if [ "X$?" != "X0" ]; then 
        echo -ne "error: failed to create mountpoint ${MOUNT_POINT}\n";
        wrap_exit 5; 
    fi
fi

mount -t ${FS_TYPE} ${DEVFILE} ${MOUNT_POINT} -o ${FS_OPTIONS};
if [ "X$?" != "X0" ]; then 
    echo -ne "error: mount failed\n";
    wrap_exit 6; 
else
    echo "Mount of ${DEVFILE} on ${MOUNT_POINT} complete" > /dev/console
fi

echo -ne "done, mounted as ${MOUNT_POINT}\n"

wrap_exit 0;
